#include <cstdlib>
#include <cstdio>
#include <iostream>
#include <cmath>
#include <vector>
#include <string>
#include <iostream>
#include <sstream>
#include <fstream>

// C includes
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
using namespace std;

// ROOT includes
#include <TSystem.h>
#include <TROOT.h>
#include <TApplication.h>
#include <TRint.h>
#include <TDirectory.h>
#include <TFile.h>
#include <TChain.h>
#include <TTree.h>
#include <TNtuple.h>
#include <TBranch.h>
#include <TH1.h>
#include <TAxis.h>
#include <TCanvas.h>
#include <TColor.h>
#include <TPad.h>
#include <TStyle.h>
#include <TKey.h>
#include <TLegend.h>
#include <TText.h>
#include <TPaveText.h>
#include <TLine.h>
#include <TMarker.h>
#include <TLatex.h>
#include <TMath.h>
#include <TH1.h>
#include <TH2.h>
#include <TF1.h>
#include <TF2.h>
#include <TString.h>
#include "TObjString.h"
#include "TRandom3.h"
#include "../include/RungeKutta.hh"
#include "../include/ElectricFieldCalc.hh"


void electric_field(double *y, double dt, double sigma_bx, double sigma_by,double sigma_bz, double gamma, double Nb, double Qb, int N_part_per_loop, double* El_field_bunch_sys, double T,  double beta, double c, double t,double dx, double dy, double dz){
    
    
  
double qe = N_part_per_loop * 1.6e-19 ; // proton charge in Coulomb
double epsilon_0 = 8.85e-12 ;
double Charge_b = Nb * qe ; // bunch charge 
double q_min=0;
double max_sigma1= max(sigma_bx, sigma_by);
double max_sigma = max(max_sigma1,sigma_bz); 

double q_max = 8 * max_sigma;
double Phi0 =  Charge_b / (4 * M_PI * epsilon_0 * sqrt(M_PI) )   ;
double x_coordinate = y[0]+dx; 
double y_coordinate = y[3]+dy;


int nn = floor((t+T/2)/ T);
double mm = t+T/2 -nn*T;
double z_coordinate = gamma * (  beta * c * (  mm - T/2) - (y[6]+dz) );
 
TF1*fx= new TF1("fx"," [0]*exp(-[1]*[1]/(x+2*[2]*[2]))*exp(-[3]*[3]/(x+2*[4]*[4]))*exp(-[5]*[5]/(x+2*[6]*[6]))/(pow(x+2*[2]*[2],3./2.)*pow(x+2*[4]*[4],1./2.)*pow(x+2*[6]*[6],1./2.))",0,q_max);
fx->SetParameters(2*x_coordinate*Phi0, x_coordinate, sigma_bx, y_coordinate, sigma_by, z_coordinate, sigma_bz );
El_field_bunch_sys[0]=fx->Integral(0.,q_max);


TF1*fy= new TF1("fy"," [0]*exp(-[1]*[1]/(x+2*[2]*[2]))*exp(-[3]*[3]/(x+2*[4]*[4]))*exp(-[5]*[5]/(x+2*[6]*[6]))/(pow(x+2*[2]*[2],1./2.)*pow(x+2*[4]*[4],3./2.)*pow(x+2*[6]*[6],1./2.))",0,q_max);
fy->SetParameters(2*y[3]*Phi0, x_coordinate, sigma_bx, y_coordinate, sigma_by, z_coordinate, sigma_bz );
El_field_bunch_sys[1]=fy->Integral(0.,q_max);

TF1*fz= new TF1("fz"," [0]* exp(-[1]*[1]/(x+2*[2]*[2]) -[3]*[3]/(x+2*[4]*[4]) -[5]*[5]/(x+2*[6]*[6]))/ ((pow(x+2*[2]*[2],1./2.)*pow(x+2*[4]*[4],1./2.)*pow(x+2*[6]*[6],3./2.)))",0,10.);
fz->SetParameters(2*z_coordinate*Phi0, x_coordinate, sigma_bx, y_coordinate, sigma_by, z_coordinate,sigma_bz);

El_field_bunch_sys[2]=fz->Integral(0.,q_max);


delete fx;
delete fy;
delete fz;



}
