#include <cstdlib>
#include <cstdio>
#include <iostream>
#include <cmath>
#include <vector>
#include <string>
#include <iostream>
#include <sstream>
#include <fstream>
// C includes
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <limits.h>
using namespace std;

// ROOT includes
#include <TSystem.h>
#include <TROOT.h>
#include <TApplication.h>
#include <TRint.h>
#include <TDirectory.h>
#include <TFile.h>
#include <TChain.h>
#include <TTree.h>
#include <TNtuple.h>
#include <TBranch.h>
#include <TH1.h>
#include <TAxis.h>
#include <TCanvas.h>
#include <TColor.h>
#include <TPad.h>
#include <TStyle.h>
#include <TKey.h>
#include <TLegend.h>
#include <TText.h>
#include <TPaveText.h>
#include <TLine.h>
#include <TMarker.h>
#include <TLatex.h>
#include <TMath.h>
#include <TH1.h>
#include <TH2.h>
#include <TF1.h>
#include <TF2.h>
#include <TString.h>
#include "TObjString.h"
#include "TRandom3.h"
#include "../include/RungeKutta.hh"
#include "../include/ElectricFieldCalc.hh"
#include <algorithm> 
// Runge-Kutta-Fehlberg Method


long double l2_norm(long double const* u, int n) {
    long double accum = 0.;
    for (int i = 0; i < n; ++i) {
        accum += u[i] * u[i];
    }
    return sqrt(accum);
}

    
void rk4(double *y, long double dt, long double dt1, double t, double sigma_bx, double sigma_by, double sigma_bz, double gamma, double beta, int N_part_per_loop,  double Qb, double Nb, double Q0, double m, double E, double* E_in_bunch_sys, double* TotField_in_lab_sys, double T, double q, double c,double tfinal,  long double tdir,   vector<double> tnew, long double*tmp){

    //int          loop_counter= 0;
    long double  hmax        = T/10.;
    double       threshold   = 1.e-3;
    double       rtol        = 1.e-05;
    long double  absh;
    long double  minh;
    double       rh; 
    double       rh_inv;
    double       temp;
    double       newabsh     = 0;
    long double *ff= new long double[9];
                 for(int i=0;i<9;i++) ff[i]=0;
    long double* f=new long double[63];
                 for(int i=0;i<63;i++) f[i]=0;
    double       E1 = 71./57600;
    double       E2 = 0;
    double       E3 = -71./16695;
    double       E4 = 71./1920;
    double       E5 = -17253./339200;
    double       E6 = 22./525;
    double       E7 = -1./40;
    double* old_y= new double[9];
    for(int i=0;i<9;i++) old_y[i]=abs(y[i]);
    double* previous_y= new double[9];
    for(int i=0;i<9;i++) previous_y[i]=y[i];  
    double       xf5  = 0;
    double       vf5  = 0;
    double       xyf5 = 0;
    double       vyf5 = 0;
    double       xzf5 = 0;
    double       vzf5 = 0;

    
    

    
    if(t==0) {// If it is the first step of the particle, forsee a step. This code is a copy of the matlab one
            minh=16*abs(nextafter((double)t,  std::numeric_limits<double>::epsilon()) - (double)t);
            absh = (min(hmax, dt1));
            double dx=0;
            double dy=0;
            double dz=0;
            electric_field(y, dt, sigma_bx, sigma_by, sigma_bz, gamma, Nb, Qb, N_part_per_loop, E_in_bunch_sys, T,  beta, c, t,dx,dy,dz);
            double Ex_in_lab_sys = E_in_bunch_sys[0]*gamma;
            double Ey_in_lab_sys = E_in_bunch_sys[1]*gamma;
            double Ez_in_lab_sys = E_in_bunch_sys[2];
            double CC = 1 - y[7] /c * beta ; 
            double Arx = Q0*q/ m* Ex_in_lab_sys* CC ;
            double Ary = Q0*q/ m* Ey_in_lab_sys* CC ;
            double Arz = Q0*q/ m* (Ez_in_lab_sys  + beta * y[1] / c * Ex_in_lab_sys + beta * y[4]/ c * Ey_in_lab_sys  ) ;
            long double*f0=new long double[9];
            f0[0]=0;
            f0[1]=Arx;
            f0[2]=0;
            f0[3]=0;
            f0[4]=Q0*q*E/m +Ary;
            f0[5]=0;
            f0[6]=0;
            f0[7]=Arz;
            f0[8]=0; 
            long double* ssum=new long double[9];
            for(int i=0;i<9;i++) ssum[i] = f0[i]/max((long double)y[i], (long double)threshold);
            rh = l2_norm( ssum,9) / (0.8 * pow(rtol,0.2));
            tnew.push_back(20);
            if (absh * rh > 1)  {absh= (1 / rh);}
            absh= max(absh, minh);
            tmp[0]=absh;
            delete f0;
            delete ssum;
             }
  
  
    temp=0;
    //loop_counter=0;
    double err = 20;
    while(err>rtol){    
    if(t!=0 && temp<=0.2)       { absh= 5.*(tnew.at(tnew.size()-1)/4.5 );
                                  dt= tnew.at(tnew.size()-1);
                                 }
    if(t!=0 &&temp>0.2)         { absh=newabsh;
                                   dt= tnew.at(tnew.size()-1)/10;
                                }                       
                                      
            
    minh =16* TMath::Abs( nextafter((double) dt,  std::numeric_limits<double>::epsilon()) - (double) dt);
    absh= min(hmax,max(minh,absh));
    long double h = tdir*(absh); 
    dt=h;
    

     if(t!=0)  {  
                  t= tnew.at(tnew.size()-1);
                }
                
    tmp[0]=dt; 

    if(1.1*(absh)>=abs(tfinal-t)) {
       dt=abs(tfinal-t);
       cout << "CHECK LOOP " <<endl;
       exit(0);
                                    }
                                       
    if(t!=0)t=tmp[1];
    
    double dx=0;
    double dy=0;
    double dz=0;
    double acc_due_to_ddp = Q0*q*E/m;  

    electric_field(y, dt, sigma_bx, sigma_by, sigma_bz, gamma, Nb, Qb, N_part_per_loop, E_in_bunch_sys, T,  beta, c, t,dx,dy,dz);
    
    double Ex_in_lab_sys = E_in_bunch_sys[0]*gamma;
    double Ey_in_lab_sys = E_in_bunch_sys[1]*gamma;
    double Ez_in_lab_sys = E_in_bunch_sys[2];
    double CC = 1 - y[7] /c * beta ;  // y[7] = vz;
    double Arx = Q0*q/ m* Ex_in_lab_sys* CC ;
    double Ary = Q0*q/ m* Ey_in_lab_sys* CC ;
    double Arz = Q0*q/ m* (Ez_in_lab_sys  + beta * y[1] / c * Ex_in_lab_sys + beta * y[4]/ c * Ey_in_lab_sys  ) ;
    y[2]=Arx;            
    y[5]=acc_due_to_ddp+Ary;
    y[8]=Arz;
    

    
    double x=y[0];
    double v=y[1];
    double a=y[2];

    double xy=y[3];
    double vy=y[4];
    double ay=y[5];
    
    double xz=y[6];
    double vz=y[7];
    double az=y[8];    
    
    double x1=x;
    double v1=v;
    double a1=y[2];
    
    double xy1=xy;
    double vy1=vy;
    double ay1=y[5];   
        
    double xz1=xz;
    double vz1=vz;
    double az1=y[8];  
    
    dx=0.2*v1*dt;
    dy=0.2*vy1*dt;
    dz=0.2*vz1*dt;
    
    electric_field(y, dt, sigma_bx, sigma_by, sigma_bz, gamma, Nb, Qb, N_part_per_loop, E_in_bunch_sys, T,  beta, c, t+0.2*dt, dx, dy, dz);
    
    // Fields in lab sys:
    // a. electric only
    Ex_in_lab_sys = E_in_bunch_sys[0]*gamma;
    Ey_in_lab_sys = E_in_bunch_sys[1]*gamma;
    Ez_in_lab_sys = E_in_bunch_sys[2];
    CC = 1 - y[7] /c * beta ;  
    Arx = Q0*q/ m* Ex_in_lab_sys* CC ;
    Ary = Q0*q/ m* Ey_in_lab_sys* CC ;
    Arz = Q0*q/ m* (Ez_in_lab_sys  + beta * y[1] / c * Ex_in_lab_sys + beta * y[4]/ c * Ey_in_lab_sys  ) ;
    
    y[2]=Arx;            
    y[5]=acc_due_to_ddp+Ary;
    y[8]=Arz;
    
    

    
    double x2=x + 0.2*v1*dt;
    double v2=v + 0.2*a1*dt;
    double a2 = y[2] ;

    double xy2=xy + 0.2*vy1*dt;
    double vy2=vy + 0.2*ay1*dt;
    double ay2 =y[5];  

    double xz2=xz + 0.2*vz1*dt;
    double vz2=vz + 0.2*az1*dt;
    double az2 =y[8];



    f[0]=v* E1;
    f[1]=a* E1;
    f[2]=0* E1;
    f[3]=vy*E1;
    f[4]=ay*E1;
    f[5]=0* E1;
    f[6]=vz*E1;
    f[7]=az*E1;
    f[8]=0* E1;
    
    
    f[9]= v2* E2;
    f[10]=a2* E2;
    f[11]=0*  E2;
    f[12]=vy2*E2;
    f[13]=ay2*E2;
    f[14]=0*  E2;
    f[15]=vz2*E2;
    f[16]=az2*E2;
    f[17]=0*  E2;

    
    
    dx = v1 *3./40.*dt +9./40.*v2*dt;
    dy = vy1*3./40.*dt +9./40.*vy2*dt;
    dz = vz1*3./40.*dt +9./40.*vz2*dt;
    
    
    electric_field(y, dt, sigma_bx, sigma_by, sigma_bz, gamma, Nb, Qb, N_part_per_loop, E_in_bunch_sys, T,  beta, c, t +3./10.*dt, dx, dy, dz);
    
    // Fields in lab sys:
    // a. electric only
    Ex_in_lab_sys = E_in_bunch_sys[0]*gamma;
    Ey_in_lab_sys = E_in_bunch_sys[1]*gamma;
    Ez_in_lab_sys = E_in_bunch_sys[2];
    CC = 1 - y[7] /c * beta ;  
    Arx = Q0*q/ m* Ex_in_lab_sys* CC ;
    Ary = Q0*q/ m* Ey_in_lab_sys* CC ;
    Arz = Q0*q/ m* (Ez_in_lab_sys  + beta * y[1] / c * Ex_in_lab_sys + beta * y[4]/ c * Ey_in_lab_sys  ) ;
    
    y[2]=Arx;            
    y[5]=acc_due_to_ddp+Ary;
    y[8]=Arz;
    
    double x3=x + v1*3./40.*dt +9./40.*v2*dt;
    double v3=v + a1*3./40.*dt +9./40.*a2*dt;;
    double a3 = y[2];
   

    double xy3=xy + vy1*3./40.*dt +9./40.*vy2*dt;
    double vy3=vy + ay1*3./40.*dt +9./40.*ay2*dt;;
    double ay3 =y[5];
    
    double xz3=xz + vz1*3./40.*dt +9./40.*vz2*dt;
    double vz3=vz + az1*3./40.*dt +9./40.*az2*dt;;
    double az3 =y[8];
    

    f[18]= v3* E3;
    f[19]= a3* E3;
    f[20]= 0*  E3;
    f[21]= vy3*E3;
    f[22]= ay3*E3;
    f[23]= 0*  E3;
    f[24]= vz3*E3;
    f[25]= az3*E3;
    f[26]= 0*  E3;

    
    
    dx = v1*44./45.*dt + v2*(-56./15.)*dt +v3*(32./9.)*dt;
    dy = vy1*44./45.*dt + vy2*(-56./15.)*dt +vy3*(32./9.)*dt;
    dz = vz1*44./45.*dt + vz2*(-56./15.)*dt +vz3*(32./9.)*dt;
    
    
    electric_field(y, dt, sigma_bx, sigma_by, sigma_bz, gamma, Nb, Qb, N_part_per_loop, E_in_bunch_sys, T,  beta, c, t+4./5.*dt, dx, dy, dz);
    // Fields in lab sys:
    // a. electric only
    Ex_in_lab_sys = E_in_bunch_sys[0]*gamma;
    Ey_in_lab_sys = E_in_bunch_sys[1]*gamma;
    Ez_in_lab_sys = E_in_bunch_sys[2];
    CC = 1 - y[7] /c * beta ;  // y[7] = vz;
    Arx = Q0*q/ m* Ex_in_lab_sys* CC ;
    Ary = Q0*q/ m* Ey_in_lab_sys* CC ;
    Arz = Q0*q/ m* (Ez_in_lab_sys  + beta * y[1] / c * Ex_in_lab_sys + beta * y[4]/ c * Ey_in_lab_sys  ) ;
    
    y[2]=Arx;            
    y[5]=acc_due_to_ddp+Ary;
    y[8]=Arz;
    
    
    
    double x4=x + v1*44./45.*dt + v2*(-56./15.)*dt +v3*(32./9.)*dt;
    double v4=v + a1*44./45.*dt + a2*(-56./15.)*dt +a3*(32./9.)*dt;
    double a4 = y[2];   
    
    double xy4=xy + vy1*44./45.*dt + vy2*(-56./15.)*dt +vy3*(32./9.)*dt;
    double vy4=vy + ay1*44./45.*dt + ay2*(-56./15.)*dt +ay3*(32./9.)*dt;
    double ay4 =y[5];   
    
    double xz4=xz + vz1*44./45.*dt + vz2*(-56./15.)*dt +vz3*(32./9.)*dt;
    double vz4=vz + az1*44./45.*dt + az2*(-56./15.)*dt +az3*(32./9.)*dt;
    double az4 =y[8];  
    
    
    f[27]=v4*E4;
    f[28]=a4*E4;
    f[29]=0*E4;
    f[30]=vy4*E4;
    f[31]=ay4*E4;
    f[32]=0*E4;
    f[33]=vz4*E4;
    f[34]=az4*E4;
    f[35]=0*E4;

    dx = v1*(19372./6561.)*dt + v2*(-25360./2187.)*dt + v3*(64448./6561.)*dt + v4*(-212./729.)*dt;
    dy = vy1*(19372./6561.)*dt + vy2*(-25360./2187.)*dt + vy3*(64448./6561.)*dt + vy4*(-212./729.)*dt;
    dz = vz1*(19372./6561.)*dt + vz2*(-25360./2187.)*dt + vz3*(64448./6561.)*dt + vz4*(-212./729.)*dt;
    
    
    electric_field(y, dt, sigma_bx, sigma_by, sigma_bz, gamma, Nb, Qb, N_part_per_loop, E_in_bunch_sys, T,  beta, c, t+8./9.*dt, dx, dy, dz);
    // Fields in lab sys:
    // a. electric only
    Ex_in_lab_sys = E_in_bunch_sys[0]*gamma;
    Ey_in_lab_sys = E_in_bunch_sys[1]*gamma;
    Ez_in_lab_sys = E_in_bunch_sys[2];
    CC = 1 - y[7] /c * beta ;  // y[7] = vz;
    Arx = Q0*q/ m* Ex_in_lab_sys* CC ;
    Ary = Q0*q/ m* Ey_in_lab_sys* CC ;
    Arz = Q0*q/ m* (Ez_in_lab_sys  + beta * y[1] / c * Ex_in_lab_sys + beta * y[4]/ c * Ey_in_lab_sys  ) ;
    
    y[2]=Arx;            
    y[5]=acc_due_to_ddp+Ary;
    y[8]=Arz;

    // FIELDS INFO. 
    TotField_in_lab_sys[0]=Ex_in_lab_sys* CC;
    TotField_in_lab_sys[1]=Ey_in_lab_sys* CC;
    TotField_in_lab_sys[2]=(Ez_in_lab_sys  + beta * y[1] / c * Ex_in_lab_sys + beta * y[4]/ c * Ey_in_lab_sys  ) ;
    TotField_in_lab_sys[3]=E;// External Electric Fied along y 
    int nn = floor((t+dt+T/2)/ T);
    double mm = t+dt+T/2 -nn*T;
    double z_coordinate = gamma * (  beta * c * (  mm - T/2) - (y[6]+dz) );

    TotField_in_lab_sys[4]=z_coordinate;
    
    
    
    double x5 = x+ v1*(19372./6561.)*dt + v2*(-25360./2187.)*dt + v3*(64448./6561.)*dt + v4*(-212./729.)*dt;
    double v5 = v+ a1*(19372./6561.)*dt + a2*(-25360./2187.)*dt + a3*(64448./6561.)*dt + a4*(-212./729.)*dt;
    double a5 =  y[2];

    double xy5 = xy+ vy1*(19372./6561.)*dt + vy2*(-25360./2187.)*dt + vy3*(64448./6561.)*dt + vy4*(-212./729.)*dt;
    double vy5 = vy+ ay1*(19372./6561.)*dt + ay2*(-25360./2187.)*dt + ay3*(64448./6561.)*dt + ay4*(-212./729.)*dt;
    double ay5 = y[5];

    double xz5 = xz+ vz1*(19372./6561.)*dt + vz2*(-25360./2187.)*dt + vz3*(64448./6561.)*dt + vz4*(-212./729.)*dt;
    double vz5 = vz+ az1*(19372./6561.)*dt + az2*(-25360./2187.)*dt + az3*(64448./6561.)*dt + az4*(-212./729.)*dt;
    double az5 = y[8];



    f[36]=v5*E5;
    f[37]=a5*E5;
    f[38]=0*E5;
    f[39]=vy5*E5;
    f[40]=ay5*E5;
    f[41]=0*E5;
    f[42]=vz5*E5;
    f[43]=az5*E5;
    f[44]=0*E5;
    
    
    
    dx = v1*(9017./3168.)*dt  + v2*(-355./33.)*dt  + v3*(46732./5247.)*dt + v4*(49./176.)*dt + v5*(-5103./18656.)*dt;
    dy = vy1*(9017./3168.)*dt + vy2*(-355./33.)*dt + vy3*(46732./5247.)*dt + vy4*(49./176.)*dt + vy5*(-5103./18656.)*dt;
    dz = vz1*(9017./3168.)*dt + vz2*(-355./33.)*dt + vz3*(46732./5247.)*dt + vz4*(49./176.)*dt + vz5*(-5103./18656.)*dt;
    
    electric_field(y, dt, sigma_bx, sigma_by, sigma_bz, gamma, Nb, Qb, N_part_per_loop, E_in_bunch_sys, T,  beta, c, t+dt, dx, dy, dz);  
    // Fields in lab sys:
    // a. electric only
    Ex_in_lab_sys = E_in_bunch_sys[0]*gamma;
    Ey_in_lab_sys = E_in_bunch_sys[1]*gamma;
    Ez_in_lab_sys = E_in_bunch_sys[2];
    CC = 1 - y[7] /c * beta ;  
    Arx = Q0*q/ m* Ex_in_lab_sys* CC ;
    Ary = Q0*q/ m* Ey_in_lab_sys* CC ;
    Arz = Q0*q/ m* (Ez_in_lab_sys  + beta * y[1] / c * Ex_in_lab_sys + beta * y[4]/ c * Ey_in_lab_sys  ) ;
    
    y[2]=Arx;            
    y[5]=acc_due_to_ddp+Ary;
    y[8]=Arz;

    
    double x6 = x + v1*(9017./3168.)*dt + v2*(-355./33.)*dt + v3*(46732./5247.)*dt + v4*(49./176.)*dt + v5*(-5103./18656.)*dt;
    double v6 = v + a1*(9017./3168.)*dt + a2*(-355./33.)*dt + a3*(46732./5247.)*dt + a4*(49./176.)*dt + a5*(-5103./18656.)*dt;
    double a6 = y[2];
    
    double xy6 = xy + vy1*(9017./3168.)*dt + vy2*(-355./33.)*dt + vy3*(46732./5247.)*dt + vy4*(49./176.)*dt + vy5*(-5103./18656.)*dt;
    double vy6 = vy + ay1*(9017./3168.)*dt + ay2*(-355./33.)*dt + ay3*(46732./5247.)*dt + ay4*(49./176.)*dt + ay5*(-5103./18656.)*dt;
    double ay6 = y[5];

    double xz6 = xz + vz1*(9017./3168.)*dt + vz2*(-355./33.)*dt + vz3*(46732./5247.)*dt + vz4*(49./176.)*dt + vz5*(-5103./18656.)*dt;
    double vz6 = vz + az1*(9017./3168.)*dt + az2*(-355./33.)*dt + az3*(46732./5247.)*dt + az4*(49./176.)*dt + az5*(-5103./18656.)*dt;
    double az6 = y[8];
     


    f[45]=v6*E6;
    f[46]=a6*E6;
    f[47]=0*E6;
    f[48]=vy6*E6;
    f[49]=ay6*E6;
    f[50]=0*E6;
    f[51]=vz6*E6;
    f[52]=az6*E6;
    f[53]=0*E6;

    f[54]=v6*E7;
    f[55]=a6*E7;
    f[56]=0*E7;
    f[57]=vy6*E7;
    f[58]=ay6*E7;
    f[59]=0*E7;
    f[60]=vz6*E7;
    f[61]=az6*E7;
    f[62]=0*E7;
    


   
    xf5 = x + v1*(35./384.)*dt + v3*(500./1113.)*dt + v4*(125./192.)*dt + v5*(-2187./6784.)*dt + v6*(11./84.)*dt;
    vf5 = v + a1*(35./384.)*dt + a3*(500./1113.)*dt + a4*(125./192.)*dt + a5*(-2187./6784.)*dt + a6*(11./84.)*dt;


    xyf5 = xy + vy1*(35./384.)*dt + vy3*(500./1113.)*dt + vy4*(125./192.)*dt + vy5*(-2187./6784.)*dt + vy6*(11./84.)*dt;
    vyf5 = vy + ay1*(35./384.)*dt + ay3*(500./1113.)*dt + ay4*(125./192.)*dt + ay5*(-2187./6784.)*dt + ay6*(11./84.)*dt;
   
    
   
    xzf5 = xz + vz1*(35./384.)*dt + vz3*(500./1113.)*dt + vz4*(125./192.)*dt + vz5*(-2187./6784.)*dt + vz6*(11./84.)*dt;
    vzf5 = vz + az1*(35./384.)*dt + az3*(500./1113.)*dt + az4*(125./192.)*dt + az5*(-2187./6784.)*dt + az6*(11./84.)*dt;

  // Update the derivatives using the interpolating polynomial.
 
   ff[0]=f[0]+f[9] +f[18]+f[27]+f[36]+f[45]+f[54];    
   ff[1]=f[1]+f[10]+f[19]+f[28]+f[37]+f[46]+f[55]; 
   ff[2]=f[2]+f[11]+f[20]+f[29]+f[38]+f[47]+f[56];    
   ff[3]=f[3]+f[12]+f[21]+f[30]+f[39]+f[48]+f[57];    
   ff[4]=f[4]+f[13]+f[22]+f[31]+f[40]+f[49]+f[58];    
   ff[5]=f[5]+f[14]+f[23]+f[32]+f[41]+f[50]+f[59];    
   ff[6]=f[6]+f[15]+f[24]+f[33]+f[42]+f[51]+f[60];    
   ff[7]=f[7]+f[16]+f[25]+f[34]+f[43]+f[52]+f[61];    
   ff[8]=f[8]+f[17]+f[26]+f[35]+f[44]+f[53]+f[62];    


   y[0]=xf5;
   y[1]=vf5;
   y[2]=0;
   y[3]=xyf5;
   y[4]=vyf5;
   y[5]=0;
   y[6]=xzf5;
   y[7]=vzf5;
   y[8]=0;

   double* new_y= new double[9];
   for(int i=0;i<9;i++) new_y[i]=abs(y[i]);
    
   double *max_array= new double[3];
   max_array[0]= *std::max_element((old_y), old_y+9);
   max_array[1]= *std::max_element((new_y), new_y+9);
   max_array[2]= threshold;
   double maxx= *std::max_element(max_array,max_array+3);
   if(maxx!=0) {for(int i=0;i<9;i++) ff[i]=ff[i]/maxx;}
   else {for(int i=0;i<9;i++) ff[i]=0;}
   err = (long double)(l2_norm(ff,9))*absh;
   temp = 1.25*pow(err/rtol,1./5);
   if (temp>0.2 ) {
                  absh=absh/temp;
                  for(int i=0;i<9;i++) y[i]=previous_y[i];
                  //loop_counter++;
                  newabsh=absh;

                  }
                  
   //else loop_counter=3;
   

        
   delete new_y;
   delete max_array;
   
    }


   y[0]=xf5;
   y[1]=vf5;
   y[2]=0;
   y[3]=xyf5;
   y[4]=vyf5;
   y[5]=0;
   y[6]=xzf5;
   y[7]=vzf5;
   y[8]=0;
   if(tnew.size()>=1) tmp[1]=t+dt;
   delete ff;
   delete f;
   delete old_y;
   delete previous_y;
    }


    
        
